"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.configure = configure;
exports.$toggle = $toggle;
exports.$unset = $unset;
exports.$splice = $splice;
exports.$map = $map;
exports.$removeAt = $removeAt;
exports.$push = $push;
exports.$filter = $filter;
exports.$unshift = $unshift;
exports.$pop = $pop;
exports.$shift = $shift;
exports.$sort = $sort;
exports.$remove = $remove;
exports.$swap = $swap;
exports.$assign = $assign;
exports.spec = spec;
exports.$if = $if;
exports.$switch = $switch;
exports.$unless = $unless;
exports.$set = $set;
exports.$produce = $produce;
exports.$batch = $batch;
exports.updatePath = updatePath;
exports.define = define;
exports.createModifier = createModifier;
exports.defaultOf = defaultOf;
exports.actions = exports["default"] = exports.update = void 0;

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var configs = {
  // for fast performance, we process dot as separator only
  separator: ".",
  defaultValuePrefix: "@@"
};
var _Array$prototype = Array.prototype,
    arraySlice = _Array$prototype.slice,
    arrayShift = _Array$prototype.shift,
    arrayUnshift = _Array$prototype.unshift,
    arrayPush = _Array$prototype.push,
    arrayPop = _Array$prototype.pop,
    arraySplice = _Array$prototype.splice,
    arraySort = _Array$prototype.sort;
var pathCache = {};
var contextProp = "@@context";

function configure(newConfigs) {
  Object.assign(configs, newConfigs);
}

function isEqual(a, b) {
  if (a instanceof Date && b instanceof Date) return a.getTime() === b.getTime();
  return a === b;
}

var Immutable =
/*#__PURE__*/
function () {
  function Immutable(value, parent, path) {
    _classCallCheck(this, Immutable);

    this.parent = parent;
    this.value = value;
    this.path = path;
    this.children = [];
    this.childMap = {};
  }

  _createClass(Immutable, [{
    key: "apply",
    value: function apply(modifier) {
      var args = arraySlice.call(arguments, 1);

      if (typeof modifier === "string") {
        if (modifier in actions) {
          modifier = actions[modifier];
        } else {
          throw new Error("No action '".concat(modifier, "'' defined"));
        }
      } // is batch processing


      if (modifier === $batch) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = args[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var job = _step.value;

            if (isPlainObject(job)) {
              traversal(this, job);
            } else {
              if (typeof job === "function") {
                job = [job];
              }

              this.apply.apply(this, job);
            }
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator["return"] != null) {
              _iterator["return"]();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return this;
      }

      var newValue = modifier.apply(null, [this.value instanceof Date ? new Date(this.value.getTime()) : this.value].concat(args)); // need special context

      while (typeof newValue === "function") {
        newValue = newValue(this);
      } // nothing to change


      if (newValue === this) {
        return this;
      }

      if (!isEqual(newValue, this.value)) {
        this.value = newValue;
        this.change(true);
      }

      return this;
    }
  }, {
    key: "change",
    value: function change(valueUpdated) {
      var _this = this;

      // notify to parent that child value is changed
      if (this.parent) {
        this.parent.change();
      }

      if (this.children.length) {
        // if this is parent, we must clone its value
        if (!this.changed) {
          this.changed = true;
          this.value = clone(this.value);
          var _iteratorNormalCompletion2 = true;
          var _didIteratorError2 = false;
          var _iteratorError2 = undefined;

          try {
            for (var _iterator2 = this.children[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
              var x = _step2.value;

              if (x.parent === this) {
                this.value[x.path] = x.value;
              }
            }
          } catch (err) {
            _didIteratorError2 = true;
            _iteratorError2 = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
                _iterator2["return"]();
              }
            } finally {
              if (_didIteratorError2) {
                throw _iteratorError2;
              }
            }
          }
        } else if (valueUpdated) {
          this.children = this.children.filter(function (x) {
            if (x.parent === _this && x.path in _this.value) {
              x.value = _this.value[x.path];
              return true;
            } // child is removed, so we detach the child


            delete x.parent;
            delete _this.childMap[x.path];
            return false;
          });
        }
      } // update parent model


      if (this.parent) {
        this.parent.value[this.path] = this.value;
      }
    }
  }, {
    key: "backToParent",
    value: function backToParent() {
      var _this2 = this;

      // make sure child should be removed fron its parent
      this.parent.children = this.parent.children.filter(function (x) {
        return x !== _this2;
      });
      delete this.parent.childMap[this.path];
      return this.parent;
    }
  }, {
    key: "child",
    value: function child(path, defaultFactory) {
      if (path in this.childMap) {
        return this.childMap[path];
      }

      var isExisting = path in this.value;
      var child = new Immutable(this.value[path], this, path);
      this.children.push(child);
      this.childMap[path] = child;

      if (!isExisting && defaultFactory) {
        child.value = defaultFactory(this.value, path);
        child.change(true);
      }

      return child;
    }
  }, {
    key: "parsePath",
    value: function parsePath(path) {
      if (Array.isArray(path)) return path;
      var cachedPath = pathCache[path];
      if (cachedPath) return cachedPath;
      return pathCache[path] = path.split(configs.separator);
    }
  }, {
    key: "childFromPath",
    value: function childFromPath(path, defaultFactory) {
      return this.parsePath(path).reduce(function (parent, path) {
        return parent.child(path, defaultFactory);
      }, this);
    }
  }, {
    key: "descendants",
    value: function descendants(pattern, specsOrCallback) {
      var callback;

      if (pattern) {
        // match node by pattern and data must be specs
        var specs = specsOrCallback; // convert pattern to regex

        var _pattern$split = pattern.split("/"),
            _pattern$split2 = _slicedToArray(_pattern$split, 3),
            exp = _pattern$split2[1],
            flags = _pattern$split2[2];

        pattern = new RegExp(exp, flags);

        callback = function callback(value) {
          if (_typeof(value) === "object") {
            for (var key in value) {
              if (pattern.test(key)) {
                return specs;
              }
            }
          }

          return undefined;
        };
      } else {
        if (Array.isArray(specsOrCallback)) {
          // [match, ...specs]
          // callback can return false to skip checking node or return spec index
          var originalCallback = specsOrCallback[0];

          var _specs = specsOrCallback.slice(1);

          callback = function callback() {
            var result = originalCallback.apply(null, arguments);

            if (typeof result === "number") {
              return _specs[result];
            }

            return result ? _specs[0] : undefined;
          };
        } else {
          // data must be callback func, it will be called when visit node
          callback = specsOrCallback;
        }
      }

      function traversal(root, parent, path) {
        if (Array.isArray(parent) || isPlainObject(parent)) {
          for (var _i2 = 0, _Object$entries = Object.entries(parent); _i2 < _Object$entries.length; _i2++) {
            var pair = _Object$entries[_i2];
            var value = pair[1];
            var key = pair[0];
            var childPath = path.concat(key);

            var _specs2 = callback(value, key);

            if (_specs2) {
              // create node from path
              var node = root.childFromPath(childPath);
              processSpec(node, _specs2);
            }

            traversal(root, value, childPath);
          }
        }
      }

      traversal(this, this.value, []);
    }
  }]);

  return Immutable;
}();

function $toggle(current) {
  var props = arraySlice.call(arguments, 1);

  if (!props.length) {
    return !current;
  }

  var newValue = clone(current);
  var _iteratorNormalCompletion3 = true;
  var _didIteratorError3 = false;
  var _iteratorError3 = undefined;

  try {
    for (var _iterator3 = props[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
      var prop = _step3.value;
      newValue[prop] = !newValue[prop];
    }
  } catch (err) {
    _didIteratorError3 = true;
    _iteratorError3 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion3 && _iterator3["return"] != null) {
        _iterator3["return"]();
      }
    } finally {
      if (_didIteratorError3) {
        throw _iteratorError3;
      }
    }
  }

  return newValue;
}

function $unset(current) {
  var props = arraySlice.call(arguments, 1); // no prop to unset => unset its self

  if (!props.length) {
    return function (node) {
      var parent = node.parent;

      if (!parent) {
        return current;
      }

      if (node.path in parent.value) {
        if (!parent.changed) {
          parent.value = clone(parent.value);
        }

        if (Array.isArray(parent.value)) {
          parent.value.splice(node.path, 1);
        } else {
          delete parent.value[node.path];
        }

        delete node.parent;
        parent.change(true);
      } else {// not exist in parent value
      }
    };
  }

  if (!current) return;
  var newValue = current;

  if (typeof props[0] === "function") {
    var filter = props[0];

    for (var prop in current) {
      if (!filter(current[prop], prop)) {
        if (newValue === current) {
          newValue = {};
        }

        newValue[prop] = current[prop];
      }
    }

    return newValue;
  }

  var _iteratorNormalCompletion4 = true;
  var _didIteratorError4 = false;
  var _iteratorError4 = undefined;

  try {
    for (var _iterator4 = props[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
      var _prop = _step4.value;

      if (_prop in newValue) {
        if (newValue === current) {
          newValue = clone(current);
        }

        delete newValue[_prop];
      }
    }
  } catch (err) {
    _didIteratorError4 = true;
    _iteratorError4 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion4 && _iterator4["return"] != null) {
        _iterator4["return"]();
      }
    } finally {
      if (_didIteratorError4) {
        throw _iteratorError4;
      }
    }
  }

  return newValue;
}

function arrayOp(array, modifier) {
  if (!array) {
    array = [];
  } else {
    array = array.slice(0);
  }

  modifier(array);
  return array;
}

function $splice(array, index, count) {
  var newItems = arraySlice.call(arguments, 3);

  if (newItems.length || count) {
    return arrayOp(array, function (x) {
      return arraySplice.apply(x, [index, count].concat(newItems));
    });
  }

  return array;
}

function $map(array, mapper) {
  var hasChange = false;
  var newArray = array.map(function () {
    var newItem = mapper.apply(this, arguments);

    if (newItem !== arguments[0]) {
      hasChange = true;
    }

    return newItem;
  });
  return hasChange ? newArray : array;
}

function $removeAt(array) {
  var indexes = arraySlice.call(arguments, 1);
  var newArray = array; // remove from bottom to top

  indexes.sort();

  while (indexes.length) {
    var index = indexes.pop();

    if (index >= 0 && index < newArray.length) {
      if (newArray === array) {
        newArray = newArray.slice();
      }

      newArray.splice(index, 1);
    }
  }

  return newArray;
}

function $push(array) {
  var newItems = arraySlice.call(arguments, 1);

  if (newItems.length) {
    return arrayOp(array, function (x) {
      return arrayPush.apply(x, newItems);
    });
  }

  return array;
}

function $filter(array, filter) {
  var newArray = array.filter(filter);
  if (newArray.length !== array.length) return newArray;
  return array;
}

function $unshift(array) {
  var newItems = arraySlice.call(arguments, 1);

  if (newItems.length) {
    return arrayOp(array, function (x) {
      return arrayUnshift.apply(x, newItems);
    });
  }

  return array;
}

function $pop(array) {
  if (!array || array.length) {
    return arrayOp(array, function (x) {
      return x.pop();
    });
  }

  return array;
}

function $shift(array) {
  if (!array || array.length) {
    return arrayOp(array, function (x) {
      return x.shift();
    });
  }

  return array;
}

function $sort(array, sorter) {
  return arrayOp(array, function (x) {
    return x.sort(sorter);
  });
}

function clone(value) {
  if (Array.isArray(value)) {
    return value.concat([]);
  }

  if (value === null || value === undefined) {
    return {};
  }

  if (isPlainObject(value)) {
    var newObject = {};

    for (var _i3 = 0, _Object$keys = Object.keys(value); _i3 < _Object$keys.length; _i3++) {
      var prop = _Object$keys[_i3];
      newObject[prop] = value[prop];
    }

    return newObject;
  }

  return value;
}

var isPlainObject = function isPlainObject(val) {
  return !!val && _typeof(val) === "object" && val.constructor === Object;
};

function $remove(array) {
  var items = arraySlice.call(arguments, 1);
  var newArray = array.filter(function (x) {
    return items.indexOf(x) === -1;
  });
  return newArray.length === array.length ? array : newArray;
}

function $swap(current, from, to) {
  var newValue = clone(current);
  var temp = newValue[from];
  newValue[from] = newValue[to];
  newValue[to] = temp;
  return newValue;
}

function $assign(obj) {
  var length = arguments.length;
  var mergedObj = obj;
  var changed = false;

  for (var index = 1; index < length; index++) {
    var value = arguments[index];

    if (value === null || value === undefined) {
      continue;
    }

    for (var _i4 = 0, _Object$keys2 = Object.keys(value); _i4 < _Object$keys2.length; _i4++) {
      var key = _Object$keys2[_i4];

      if (value[key] !== mergedObj[key]) {
        if (!changed) {
          changed = true; // clone before updating

          mergedObj = {};

          for (var _i5 = 0, _Object$keys3 = Object.keys(obj); _i5 < _Object$keys3.length; _i5++) {
            var prop = _Object$keys3[_i5];
            mergedObj[prop] = obj[prop];
          }
        }

        mergedObj[key] = value[key];
      }
    }
  }

  return mergedObj;
}

function createSelectorProxy(context) {
  var proxy = new Proxy(function (x) {
    return undefined;
  }, {
    get: function get(target, prop) {
      if (prop === contextProp) return context;
      context = context.child(prop);
      return proxy;
    },
    set: function set(target, prop, value) {
      context.apply($set, prop, value);
      return proxy;
    },
    apply: function apply(target, thisArg, args) {
      var action = context.path; // back to parent node

      context = context.backToParent();
      context.apply.apply(context, [action].concat(args));
      return proxy;
    }
  });
  return proxy;
}

function spec(value) {
  return function (node) {
    if (value) {
      processSpec(node, value);
    }

    return node;
  };
}

function $if(current, condition, thenSpec, elseSpec) {
  return spec(condition(current) ? thenSpec : elseSpec);
}

function $switch(current, makeChoice) {
  var specs = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (!(typeof makeChoice === "function")) {
    specs = makeChoice;
    makeChoice = null;
  }

  return spec(specs[typeof makeChoice === "function" ? makeChoice(current) : current] || specs["default"]);
}

function $unless(current, condition, value) {
  return spec(condition(current) ? undefined : value);
}

function $set(current, prop, value) {
  var comparer = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : isEqual;

  if (arguments.length < 3) {
    return prop;
  }

  var currentValue = typeof current === "undefined" || current === null ? undefined : current[prop];

  if (typeof value === "function") {
    value = value(currentValue, current);
  }

  if (comparer(currentValue, value)) return current;
  var newValue = clone(current);
  newValue[prop] = value;
  return newValue;
}

function $produce(current, recipe) {
  return spec(recipe(current));
}

function processSpec(child, value) {
  // is main spec
  if (typeof value[0] === "function" || typeof value[0] === "string") {
    // is modifier and its args
    child.apply.apply(child, value);
  } else {
    processSubSpec(child, value);
  }
}

function processSubSpec(child, value) {
  // is sub spec
  var spec = value[0];

  if (Array.isArray(spec)) {
    var filter = value[1];
    var limit = value[2];
    var applied = 0; // apply for each child

    for (var _i6 = 0, _Object$keys4 = Object.keys(child.value); _i6 < _Object$keys4.length; _i6++) {
      var key = _Object$keys4[_i6];

      // only apply spec for child which is satisfied filter
      if (filter && !filter(child.value[key], key)) {
        continue;
      }

      var newChild = child.child(key);
      newChild.apply.apply(newChild, spec);
      applied++;

      if (limit && applied >= limit) {
        break;
      }
    }
  } else {
    for (var _i7 = 0, _Object$keys5 = Object.keys(child.value); _i7 < _Object$keys5.length; _i7++) {
      var _key = _Object$keys5[_i7];
      traversal(child.child(_key), spec);
    }
  }
}

function traversal(parent, node) {
  for (var _i8 = 0, _Object$keys6 = Object.keys(node); _i8 < _Object$keys6.length; _i8++) {
    var key = _Object$keys6[_i8];

    // dont process default value
    if (key.indexOf(configs.defaultValuePrefix) === 0) {
      continue;
    }

    var value = node[key];

    if (key.charAt(0) === "?") {
      // is wildcard
      parent.descendants(key.substr(1), value);
      continue;
    } // convert obj method to custom modifier


    if (typeof value === "function") {
      value = [value];
    }

    var child = parent.childFromPath(key, // get default value factory
    node[configs.defaultValuePrefix + key]);

    if (Array.isArray(value)) {
      processSpec(child, value);
    } else if (isPlainObject(value)) {
      traversal(child, value);
    } else {
      child.apply($set, value);
    }
  }
} // a token to determine batch actions


function $batch() {// do nothing
}

var update = function update(state, changes) {
  // create curry func
  if (arguments.length === 1) {
    changes = state;
    return function (state) {
      return update(state, changes);
    };
  }

  var root = new Immutable(state);
  root.type = "root";

  if (arguments.length > 2) {
    // multiple specs
    processSpec(root, [$batch].concat([].slice.call(arguments, 1)));
  } else if (Array.isArray(changes)) {
    processSpec(root, changes);
  } else {
    traversal(root, changes);
  }

  return root.value;
};

exports.update = update;

function updatePath(state) {
  var root = new Immutable(state);

  for (var _len = arguments.length, specs = new Array(_len > 1 ? _len - 1 : 0), _key2 = 1; _key2 < _len; _key2++) {
    specs[_key2 - 1] = arguments[_key2];
  }

  for (var _i9 = 0, _specs3 = specs; _i9 < _specs3.length; _i9++) {
    var _spec = _specs3[_i9];

    if (typeof _spec === "function") {
      _spec = [_spec];
    }

    var selector = _spec[0];

    var args = _spec.slice(1);

    var node = selector(createSelectorProxy(root))[contextProp];

    if (args.length) {
      node.apply.apply(node, args);
    }
  }

  return root.value;
}

var _default = update;
exports["default"] = _default;
var actions = {
  $batch: $batch,
  batch: $batch,
  "=": $set,
  $assign: $assign,
  assign: $assign,
  $pop: $pop,
  pop: $pop,
  $push: $push,
  push: $push,
  $remove: $remove,
  remove: $remove,
  $set: $set,
  set: $set,
  $shift: $shift,
  shift: $shift,
  $sort: $sort,
  sort: $sort,
  $splice: $splice,
  splice: $splice,
  $toggle: $toggle,
  toggle: $toggle,
  $unset: $unset,
  unset: $unset,
  $unshift: $unshift,
  unshift: $unshift,
  $swap: $swap,
  swap: $swap,
  $removeAt: $removeAt,
  removeAt: $removeAt,
  "if": $if,
  $if: $if,
  $unless: $unless,
  unless: $unless,
  $switch: $switch,
  "switch": $switch,
  $filter: $filter,
  filter: $filter,
  map: $map,
  $map: $map,
  produce: $produce,
  $produce: $produce
};
exports.actions = actions;

function cloneIfPossible(callback) {
  return function () {
    arguments[0] = clone(arguments[0]);
    return callback.apply(null, arguments);
  };
}

function define(name, action, disableAutoClone) {
  // define(actionHash, disableAutoClone)
  if (isPlainObject(name)) {
    disableAutoClone = action;

    for (var _i10 = 0, _Object$entries2 = Object.entries(name); _i10 < _Object$entries2.length; _i10++) {
      var pair = _Object$entries2[_i10];
      actions[pair[0]] = disableAutoClone ? pair.value : cloneIfPossible(pair[1]);
    }
  } else {
    // define(name, action, disableAutoClone)
    actions[name] = disableAutoClone ? action : cloneIfPossible(action);
  }
}

function createModifier(getter, setter) {
  return Object.assign(function (specs) {
    var state = getter();
    var nextState = update(state, specs);

    if (state !== nextState) {
      setter(nextState);
    }
  }, {
    set: function set(nextState) {
      if (nextState === null || nextState === undefined) return;
      var state = getter();

      if (!state) {
        setter(nextState);
        return;
      }

      for (var prop in nextState) {
        if (state[prop] !== nextState) {
          setter(nextState);
          return;
        }
      }
    }
  });
}

function defaultOf(prop) {
  return configs.defaultValuePrefix + prop;
}
//# sourceMappingURL=index.js.map